
// example of a UDP time server

TimeRequestHandler := UDPReceiver clone do(
    socket setHost("127.0.0.1")
    setPort(8080)
    handleUDPPacketFromIP := method(packet, ip, 
	writeln("got time request from ", ip)
	socket := Socket setHost(ip) setPort(8081) udpOpen 
	if (socket error, writeln(socket error))
	socket write(Date now asString)
	writeln("processed a time request")
    )
)

write("starting a udp time server on port 8080\n")
TimeRequestHandler start


