/*#io
docCopyright("Steve Dekorte", 2002)
docLicense("BSD revised")
*/
 
#include "IoCatch.h"

void IoState_syncRetainStack(IoState *self);

void IoState_error_description_(IoState *self, IoMessage *m, const char *name, const char *format, ...);

void IoState_raiseExceptionWithName_andDescription_(IoState *self, 
    IoSymbol *name, IoSymbol *description, IoMessage *m);

IoObject *IoState_withinCatchPerform(IoState *self, IoObject *target, IoObject *locals, IoMessage *m);

IoObject *IoState_tryFunc_(IoState *self, IoCatchCallback *func, 
    void *arg1, void *arg2, void *arg3, IoException **e);
