
Object finalize := method(
  thisMessage argsEvaluatedIn(sender)

  sender setSlot := method(
    slotName := thisMessage argAt(0) doInContext(sender)
    slotValue := thisMessage argAt(1) doInContext(sender)

    if (self slotNames contains(slotName)) then (
      return super(setSlot(slotName, slotValue))
    )
    raiseException("Object.setSlot", 
      "attempt to add slot to finalized object")
  )
)

Object locals := Object getSlot("finalize")

// Example

MyObject := Object clone
MyObject foo := method(
  locals(a := 1, b := 2)
  a := 2
  b := 3
  c := 4
)

MyObject foo