// example of dynamically compiling messages in Objective-C syntax

Message buildObjcMessage := method(objcMsg,
    if (self name endsWithSeq(":")) then (
       //write(self name, " buildObjcMessage()\n")
       
	// append keyword to msg name
	objcMsg setName(objcMsg name .. self name)
	
	a := self attached
        //write("a = ", a name, "\n")
	if (a) then (
	    objcMsg setArguments(objcMsg arguments add(a))
	    if (self attached, self attached buildObjcMessage(objcMsg))
	    a setAttached(Nil)
	)
    )
    if (self attached, self attached buildObjcMessage(objcMsg))
)

squareBrackets := method(
    t := thisMessage argAt(0)
    k1 := t attached
    //write("k1 = ", k1 name, "\n")
    
    if (k1 name endsWithSeq(":")) then (
	objcMsg := Message clone
	objcMsg setName("")
	k1 buildObjcMessage(objcMsg)
	t setAttached(objcMsg)
    )
    
    // replace squareBrackets
    thisMessage setName("") 

    // do it
    sender doMessage(t)
)


a := Object clone
a show0  := method(write("unary worked!\n"))
a show1: := method(s, write("'", s, "'\n"))
a setSlot("add:and:", method(a, b, write(a + b, "\n")))

test0 := method([a show0])
test1 := method([a show1:"one keyword worked!"])
test2 := method([a add:1 and:2])

write("\ncode before:\n  ")
write(getSlot("test0") code, "\n")
write("\ncall it:\n  ")
test0
write("\ncode after:\n  ")
write(getSlot("test0") code, "\n")
write("\n")

write("------------------------------\n")


write("\ncode before:\n  ")
write(getSlot("test1") code, "\n")
write("\ncall it:\n  ")
test1
write("\ncode after:\n  ")
write(getSlot("test1") code, "\n")
write("\n")

write("------------------------------\n")

write("\ncode before:\n  ")
write(getSlot("test2") code, "\n")
write("\ncall it:\n  ")
test2
write("\ncode after:\n  ")
write(getSlot("test2") code, "\n")
write("\n")



