Lib clone do(
    if(platform == "netbsd",
	dependsOnFramework("Carbon")
	dependsOnIncude("/usr/pkg/include")
	dependsOnIncude("/usr/X11R6/include")
    )

    if(list("cygwin") contains(platform), 
	dependsOnIncude("libs/freeglut/_include")
    )

    build := method(
	resend
	trySystemCall("cd ffmpeg; make")
	trySystemCall("cp ffmpeg/*/lib*.a _libs")
	trySystemCall("cp ffmpeg/_include/* _includes")
    )
    
    clean := method(
	resend
	trySystemCall("cd ffmpeg; make clean")
	trySystemCall("cd ffmpeg; rm ffmpeg ffmpeg_g output_example qt-faststart")
    )

    configure := method(
	resend
	systemCall("chmod +x ffmpeg/configure")
	systemCall("cd ffmpeg; ./configure --enable-shared=no --disable-vhook --disable-ffserver")
    )
)