String asCharacterStringList := method(
    s := List clone
    self foreach(i, c, s add(c asCharacter))
    s
)

BigFolder := Object clone do(
  
    newSlot("path", ".")
    
    rootFolder := method(
	Directory clone setPath(path)
    )
    
    fileNamed := method(name,
	path := Buffer clone
	max := name size - 1
	
	folder := rootFolder
	
	title  := name beforeSeq(".")
	suffix := name afterSeq(".")
	
	paths := title asCharacterStringList
	fileName := paths last .. "." .. suffix
	paths removeLast
	
	paths foreach(i, folderName, 
	    folder:= folder folderNamedCreateIfAbsent(folderName)
	)
	
	File clone setPath(Path with(folder path, fileName))
    )
)
