/*
Object  setSlot("resend", method(
	senderSlotContext := sender getSlot("slotContext")
	if(thisMessage argAt(0), Exception raise("Object", "resend takes no argument"))
	senderSlotContext ifNil(Exception raise("Object", "resend called outside of block context"))
	m := sender thisMessage
	slotName := m name
	ancestor := senderSlotContext ancestorWithSlot(slotName)
	if (ancestor == Nil, writeln("ancestor == Nil"))
	if (ancestor == sender slotContext, 
		writeln("ancestor == slotContext")
		writeln("ancestor = ", ancestor uniqueId)
		writeln("slotContext = ", sender slotContext uniqueId)
	)
	if(ancestor == Nil or ancestor == senderSlotContext, Exception raise("Object", "resend slot " .. slotName .. " not found"))
	ancestor getSlot(slotName) performOn(sender getSlot("self"), sender, m, ancestor)
))
*/

View := Object clone
View resizeBy := method(x, y,
  write("View ", self uniqueId, " resizeBy(", x, ",", y, ")\n")
)

// ----------------------------------------

Scroller := View clone
Scroller resizeBy := method(x, y,
  write("Scroller ", self uniqueId, " resizeBy(", x, ",", y, ")\n")
  resend
)

Scroller clone resizeBy(1, 2)

writeln("-----------------------------------------")

Mammal := Object clone
Mammal bark := method(x, y, writeln("Mammal bark ", x, " ", y))

Dog := Mammal clone
Dog bark := method(x, y, resend; writeln("Dog bark ", x, " ", y))

fido := Dog clone
fido bark := method(x, y, resend; writeln("fido bark ", x, " ", y))

fido bark(1, 2)


Object init := method(1)
foo := Object clone 
foo init := method(resend)
foo clone